<%@ LANGUAGE=VBScript %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<HEAD>
  <title>EtherRain Alert Builder for HS2</title>
<link rel="stylesheet" type="text/css" href="/style.css"/>

<script language="JavaScript" type="text/javascript">
 <!--
 
  

   function checkMakeVars ( form )
	 {
        var tstr = "";
		var i;
		var j;
		var k = 0;
		var wstr = "";
		var nstr = "";
		// put the form params into eralert
		// in this format:  email;smins;emailalert;logalert
		// smins is number of mins after midnight; emailalert=on/off; logalert=on/off
		
		
		tstr = form.emailalert.value;
		
		if (tstr == "on") {
		   tstr = form.email.value;
		   //need the email validater here
		   if ( tstr.length == 0) {
	          alert('An email address is required when Email Alerting is selected.');
			  form.email.focus();
              return false;
	       }
		   var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
		   tstr = form.email.value;
		   
           if(reg.test(tstr) === false) {
              alert('Email Address is not valid.  Please Check.');
			  form.email.focus();
              return false;
		   }
		}
		
		//test alerts
		if (form.emailalert.value == "off" && form.logalert.value == "off" ) {
		   var huh = confirm ("No Alerts have been selected, Continue?");
		   if ( huh === false) {
		     return false;
		   }
		}
 
		/*separate shourmin into shour and smin */
		/*check that the format is hh:mm or h:mm */
		tstr = form.rt.value;
		
		
		if (tstr.length < 4 ) {
		  alert("When entering Run-time, use format HH:MM (hours : minutes)");
		  form.rt.focus();
		  return false;
		}
		var cint = tstr.indexOf(":");
		if (cint < 0 ) {
    	  alert( "When entering Run-time, separate hours from minutes with a colon(:)" );
   		  form.rt.focus();
		  return false ;
		}
		if (cint < 1) {
		  alert("When entering Run-time, enter use format HH:MM (hours : minutes)");
		  form.rt.focus();
		  return false;
		}
		if (cint == 2 && tstr.length < 5 ) {
		  alert("When entering Run-time, use two digits to specify minutes)");
		  form.rt.focus();
		  return false;
		}
	
	    var hrstr = tstr.substring(0,cint);
		var minstr = tstr.substring(cint+1);
		/* check that minutes is 60 or less and hours is 1 to 12 */
		var jint = parseInt(hrstr);
		if (jint > 12 || jint == 0 || isNaN(jint) ) {
    	  alert( "Accepted Run-time Hour values range from 1 to 12." );
   		  form.rt.focus();
		  return false ;
		}
		var startmin = jint * 60;
		jint = parseInt(minstr);
		if (jint > 60 || isNaN(jint) ) {
    	  alert( "Accepted Run-time Minute values range from 0 to 60." );
   		  form.rt.focus();
		  return false ;
		}
		startmin = startmin + jint;
		//factor in ampm
		var ampmIndex = form.ampm.selectedIndex;
		var ampmSelected = form.ampm[ampmIndex].value
		//alert("index: " + ampmIndex + " " + ampmSelected);

		if (ampmSelected == "PM" ) {
		      startmin = startmin +720 ;
		}
		//alert(form.ampm[ampmIndex].value);
		//alert(startmin);
		
		if (ampmSelected == "AM" && startmin >= 720 ) {
		      startmin = startmin - 720;
		}
		
       //now put all the data into one string
	   	//eaddress;smins;emailalert;logalert

	    wstr = form.email.value + ";" + startmin + ";" + form.emailalert.value + ";" + form.logalert.value;
		//alert(wstr);
	    form.eralert.value = wstr;
		//return false;
		return true;
		  
		}

   function clearForm ( form )
	 {
        var tstr = "";
		var i;
		var k;		
		k = confirm("This will clear all fields on the form.  Continue?");
		//alert(k);
		if (k) {
		   document.controllerform.cn.value = ""; 
		   document.controllerform.cp.value = "";
		   for (i=1;i <= 8;i++) {
		       tstr = "z" + i ;
	 	       document.controllerform[tstr].value = "";
	       }
  		}

	   return
     }


	 
	//-->
</script> 

</head>


<%
Dim numlines 
'Dim progAry(20,9)   '20 lines, 9 params per line
Dim cAry
dim editmode
Dim rstr

'page globals for alerts:
 Dim  	eaddress  		 
 Dim 	smins 	    '- minutes from midnight
 Dim    stime		'- conversion of smins to hrs:mins
 Dim    ampm		'-  conversion of smins to hrs:mins AM or PM
 Dim	emailalert  '- stored as "off" or "on"
 Dim	logalert    '- stored as "off" or "on"

  
 Function readAlertConfig
   'see also updateAlertConfig function on the home page
   'this function duplicated on home page
  Dim aVar
  Dim i
  Dim j
  dim tstr
   
 'get the following
 'start time, in minutes; convert to string hours:minutes and AM/PM
 'get the email address
 'get the email option (0 or 1)
 'get the log option (0 or 1)
 
 	aVar = ""
	section = hs.GetINISection("alerts_config", "EtherRain.ini")
	if len(section) > 0 then
		items = split(section,chr(0))
		for i = 0 to ubound(items)
		      'Response.Write "<p><b>Item " & items(i) & "</b></p><hr>"
			  j = instr(items(i),"eralerts=")
			  if j > 0 then 
			    aVar = mid(items(i),j+9)
				exit for
			  end if
		next 
	    end if
	
	    'provide default initialization
		eaddress =""
		smins = 180
		emailalert = "off"
		logalert = "off"
		  
	   if len(aVar) > 0  then'parse the storage variable here
	      'there is only one parameter in this string, this are no "|" separators
	      'the values are separated by ";"
	      params = split(aVar, ";")
		  if ubound(params) = 3 then
		    eaddress = params(0)
			smins = params(1)
			emailalert = params(2)
			logalert = params(3)
		  end if

	end if


'convert smins to hrs:mins
   ampm = "am"
   if smins > 720 then 
      ampm = "pm"
	  smins = smins-720
   elseIf smins < 60 then 
        ampm = "am"
	    smins = smins+720
   
   end if
   i = Cint(smins) \ 60
   j = Cint(smins) mod 60
   tstr = Cstr(j)
   if len(tstr) <2 then tstr = tstr & "0"
   stime = Cstr(i) & ":" & tstr
	  

 End Function
 

'    ***End Function Declaration***


'    **** main script block  *****

'this page posts to the home page

 readAlertConfig()  'this gets the variables from ini or initializes if no stored section


%>

<body style= "margin-left: 4%; margin-right: 4%; background:white; 
			 color: black; 
			 font-size: 11px;
			 font-weight: normal;
			 font-family: verdana, arial, sans-serif;"
>

	  <div style="float:left; width:638px; height:26px;padding-top:3px;padding-left:2px; background-color: black;border-bottom:solid 2px grey;">
	   
	  <input style="width:120px;" type="button" class="linkrowbutton" value="HomeSeer Start" alt="Start" onClick="location.href='/start/start.aspx'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="HomeSeer Home" alt="Home" onClick="location.href='/'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="EtherRain Home" alt="EtherRain Home" onClick="location.href='er_home.asp'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  <input style="width:120px;" type="button" class="linkrowbutton" value="EtherRain Help" alt="EtherRain Help" onClick="location.href='er_help.asp'" onmouseover="this.className='linkrowbuttonselected';" onmouseout="this.className='linkrowbutton';">
	  </div>

    <div style="float:left; width:640px; text-align: center;
			font-size: 11px; font-weight: normal;
	         text-align:center;   /* hack for ie5  */
			font-family: verdana, arial, sans-serif; ">
   

    <div style="float:left; width: 638px;height:60px; 
		        border: 1px solid forestgreen;
			    background-color: lightgreen;
				font:arial, sans-serif; ">
		 <div style="float:left; width: 80px;margin-top:6px;">
	         <img style= "float:left; padding-left:35px;" align="middle" alt="EtherRain Logo" src="ershieldlogo.png" />  
	     </div>
		 <div style= "float:left;width: 480px;padding-top:7px;">
              <p style="color:white;font-weight:600; font-size:24px;
			            margin-top:5px; margin-bottom:2px;padding-top:5px;text-align:center;">
		             EtherRain Alert Setup
			  </p>
		 </div>
    </div>

    <div style="float:left; width:638px;height:600px;margin-top:2px;border:1px solid silver;
			text-align:left; overflow: auto;">
	       <p style="padding-left:40px; padding-right:30px; margin-top:8px;text-align:justify;">
		    From this page you can set up an event to provide operating alerts for your 
			EtherRain controllers.  If either Email or Log options are selected, the EtherRain controller 
			check event will run automatically every day at the specified run time. 
		   </p>
		   <p style="padding-left:40px; padding-right:30px; margin-top:8px;text-align:justify;">
			Alerts can be delivered to you via email or via log entry or both.  
			If the "email alert" option is selected, an email message will be sent if any of 
			the defined controllers fail to respond to the check event.  If "log alert" is selected, a 
			HomeSeer log entry will be made every time the event is triggers, with results noted.  
			
 	        </p>
			<p style="padding-left:40px; padding-right:30px; margin-top:8px;text-align:justify;">
	  		For email alerts to function your HomeSeer 2 server must be properly configured with 
			an email server.
 	        </p>
			
      <form name="alertform" action="er_home.asp" method="post" onsubmit="return checkMakeVars(this);">
			<table style="text-align: center;font-family: Verdana, sans-serif, Arial;
	   			   font-weight: normal;
				  color: #404040;
				  width: 400px;
				  border-collapse: collapse;
				  border-spacing: 0px;"
 				  cellspacing="0" cellpadding="5" align="center" border="0">
         		  <thead bgcolor=whitesmoke >
		  <tbody >
            <tr style="border-bottom: 1px dotted #d79900;text-align: left; font-family: Verdana; font-weight: 400;color: #404040;">
                <td style="padding-left:15px; text-align:left;width:150px;font-size:11px;">Daily Run Time:</td>
		        <td style="text-align:left;font-size:11px;padding-left:10px;">
			  	 <INPUT style="width:40px;font-size:11px;" TYPE="text" NAME="rt" value = "<% Response.Write stime %>" maxlength="5" SIZE="6">
			  	 <SELECT style="width:50px;font-size:11px;" name="ampm"> 
				<%
				   if ampm = "am" then 
				     Response.Write "<OPTION selected value = ""AM""> AM </OPTION>"
				     Response.Write "<OPTION  value = ""PM""> PM </OPTION>"
				   else 	 
				     Response.Write "<OPTION  value = ""AM""> AM </OPTION>"
				     Response.Write "<OPTION selected value = ""PM""> PM </OPTION>"
				   end if	 
				%> 
		        </td>
		    </tr>
            <tr style="border-bottom: 1px dotted #d79900;text-align: left; font-family: Verdana; font-weight: 400;color: #404040;">
                <td style="padding-left:15px; text-align:left;width:150px;font-size:11px;">Email Address:</td>
		        <td style="text-align:left;font-size:11px;padding-left:10px;">
			  	 <INPUT style="width:120px;font-size:11px;" TYPE="text" NAME="email" value = "<% Response.Write eaddress %>" maxlength="35" SIZE="30">
		        </td>
		    </tr>
            <tr style="border-bottom: 1px dotted #d79900;text-align: left; font-family: Verdana; font-weight: 400;color: #404040;">
                <td style="padding-left:15px; text-align:left;width:150px;font-size:11px;">Email Alerts:</td>
		        <td style="text-align:left;font-size:11px;padding-left:10px;">
		  	    <SELECT style="width:50px;font-size:11px;" name="emailalert"> 
				<%
				   if emailalert = "on" then 
				     Response.Write "<OPTION selected value = ""on""> ON </OPTION>"
				     Response.Write "<OPTION  value = ""off""> OFF </OPTION>"
				   else 	 
				     Response.Write "<OPTION  value = ""on""> ON </OPTION>"
				     Response.Write "<OPTION selected value = ""off""> OFF </OPTION>"
				   end if	 
				%> 
		        </td>
		    </tr>
            <tr style="border-bottom: 1px dotted #d79900;text-align: left; font-family: Verdana; font-weight: 400;color: #404040;">
                <td style="padding-left:15px; text-align:left;width:150px;font-size:11px;">HomeSeer Log Alerts:</td>
		        <td style="text-align:left;font-size:11px;padding-left:10px;">
		  	    <SELECT style="width:50px;font-size:11px;" name="logalert"> 
				<%
				   if logalert = "on" then 
				     Response.Write "<OPTION selected value = ""on""> ON </OPTION>"
				     Response.Write "<OPTION  value = ""off""> OFF </OPTION>"
				   else 	 
				     Response.Write "<OPTION  value = ""on""> ON </OPTION>"
				     Response.Write "<OPTION selected value = ""off""> OFF </OPTION>"
				   end if	 
				%> 
		        </td>
		    </tr>
            <tr style="border-bottom: 1px dotted #d79900;text-align: left; font-family: Verdana; font-weight: 400;color: #404040;">
                <td style="padding-left:15px; text-align:left;width:150px;font-size:11px;" rowspan=2>&nbsp;</td>
		    </tr>
          </tbody>
        </table>
		<INPUT TYPE="hidden" NAME = "postcheck" VALUE="1" />
		<INPUT TYPE="hidden" NAME = "eralert" VALUE="" />
        <p style="font-size:14px;margin-top:10px; margin-bottom:10px;padding-left: 45px; text-align:center; font:arial; ">
           <input type="submit" value="Update Alerts" /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		</p>
  </form>

    </div>
     <p style="padding-left:10px;  font-size:10px; text-align:left; ">
          &copy; 2009 QuickSmart Development www.quicksmart.com
      </p>
   </div>

 </body>
</html>
